/*
 * payload.S -- Adds system call 8 code on custom firmware
 * 
 * It contains hermes v4 parts of code
 */

#include "firmware_symbols.h"

#define DISABLE_HERMES_RESIDENT 0 //Hermes mode or sys36-mode

#define DESTINATION_HERMES     0x7FF000
#define DESTINATION_SYSCALL36  0x2BE4A0 
#define DESTINATION_PL3        0x00EF48

#if DISABLE_HERMES_RESIDENT
    #define BASE DESTINATION_SYSCALL36 - 0
#else
    #define BASE (DESTINATION_HERMES-(resident_code-destination_code))
#endif


#define ABS(target) ((target) - (BASE) - .)
#define QUAD_ABS(address) .quad 0x8000000000000000 + BASE + address

// Dynamic macros to load a label into a register
#define MEM_BASE(dest) \
	li      dest, 1; \
	rldicr  dest, dest, 63, 0;
#define LOAD_LABEL(dest, source, address) \
	oris	dest, source, ((BASE) + (address))@h; \
	ori		dest, dest, ((BASE) + (address))@l;

// For loading an absolute value
#define LOAD_ABS(dest, source, address)  \
	oris	dest, source, ((address))@h; \
	ori		dest, dest, ((address))@l;

#define SYS8_VERSION 0x100
#define PERM_MODE 2  // 0 -> restricted 1-> original 2-> new for some games

#define RESIDENT_AREA_OFFSET	(resident_area_start)

#define ADDR_IN_MEM2(target) 	((target) - RESIDENT_AREA_OFFSET)

#define LOAD_LABELB(base, dest, source, address) \
	oris	dest, source, ((base) + (address))@h; \
	ori	dest, dest, ((base) + (address))@l;
#define LOAD_LABEL2(dest, source, address) \
	LOAD_LABELB(MEM_BASE2, dest, source, ADDR_IN_MEM2 (address))

// Add system calls. Use only in exploit_main because of registers used...
#define ADD_SYSCALL(source, ptr, num)			\
	LOAD_LABEL2 (%r3, source, ptr); 		\
	LOAD_ABS (%r4, source, syscall_table); 		\
	std	%r3, 0x08*num(%r4); 			\


.org 0
#if DISABLE_HERMES_RESIDENT
aDS016lx016llx0:.string	"%d%s%016lx%016llx%016llx%s%s%08x%d%1d%1d%1dAAA\n"

#else
destination_code:


# copy code and jump to main
 exploit_entry: 

    b       payload_install
 
    .byte 'H', 'S', 'C','8'

payload_install:

// memset 0 from  BASE to DESTINATION
zero_payload:

	ld	    %r27, 0x78(%sp)
	ld	    %r28, 0x80(%sp)
	ld	    %r29, 0x88(%sp)
	ld  	%r30, 0x90(%sp)
	ld	    %r31, 0x98(%sp)
	ld	    %r0,  0xb0(%sp)
	addi	%sp, %sp, 0xa0
	mtlr	%r0
	
	MEM_BASE(%r3)
	oris	%r3, %r3, (BASE)@h
	ori	    %r3, %r3, (BASE)@l
	li	    %r4, 0
	li	    %r5, (resident_code)@l
	b	    ABS(memset)

patch_table_data:

# 007xxxxx
	.long 0

########################################################################################################################################################
	.quad 0

resident_code:

return1:
	li	    %r3, 1
    blr
		 
return0:
	li      %r3, 0
    blr
#endif


# 000xxxx
#syscall8_desc:
#	QUAD_ABS(syscal8)
#	.quad USER_DATA //user data on 3.55?


########################################################################################################################################################

# generic tool main syscall

syscall8:

	mflr    %r0
	stdu    %sp, -0xA0(%sp)
	std     %r27, 0x78(%sp)
	std     %r28, 0x80(%sp)
	std     %r29, 0x88(%sp)
	std     %r30, 0x90(%sp)
	std     %r31, 0x98(%sp)
	std     %r0, 0xB0(%sp)

	MEM_BASE(%r31)

	LOAD_LABEL(%r27, %r31, save_syscall_values)
	
	lwz     %r28, 0(%r27)	   // stealth mode
	cmplwi  %r28, 0x0
	beq	    syscall8_ok	   // if not stealth mode work normally

	cmplwi  %r28, 8
	bge	    syscall8_stealth // if stealth mode >=8 ignore all
	
	cmpldi  %r3, 1	           // test for command == 1
    bne	    syscall8_stealth

	cmpldi  %r4, 0	           // compare if key is 0 to skip count times
    beq	    syscall8_skip_count

	addi	%r28, %r28, 1	  // stealth_mode++ (count times)
	stw     %r28, 0(%r27)

 syscall8_skip_count:

	ld      %r28,  8(%r27)	   // get key and compares if same key
	cmpld	%r4, %r28
    bne	    syscall8_stealth
	li	    %r28, 1
	stw     %r28, 0(%r27) // stealth mode

// syscall8 enabled: system_call_2(8, 1, key)
	
	LOAD_ABS(%r4, %r31, SYSCALL_TABLE)

	//ld      %r28,  16(%r27)
	//std     %r28,  6*8(%r4) // patch syscall 6 to enable

	//ld      %r28,  24(%r27)
	//std     %r28,  7*8(%r4) // patch syscall 7 to enable
	
	//LOAD_LABEL(%r28, %r31, payload1_start)
	//std     %r28, 36*8(%r4) // patch syscall 36 to enable

	li	    %r28, 0
	stw     %r28, 0(%r27) // stealth mode off
	
	li	    %r3, SYS8_VERSION
	b	    syscall8_end

 syscall8_ok:

// syscall switch

	andi.   %r3, %r3, 0xff
	cmpldi  %r3, 12
	bge	syscall8_unsupported
	
	LOAD_LABEL(%r27, %r31, syscall8_table)
	sldi 	%r28, %r3, 3
	add 	%r27, %r27, %r28
	
	ld	    %r29, 0(%r27)

// move param registers
	mr      %r3, %r4
	mr      %r4, %r5
	mr      %r5, %r6

// jump to register address with link
	bl	    syscall8_bl

 syscall8_end:

	ld      %r27, 0x78(%sp)
    ld      %r28, 0x80(%sp)
    ld      %r29, 0x88(%sp)
    ld      %r30, 0x90(%sp)
    ld      %r31, 0x98(%sp)
    ld      %r0, 0xB0(%sp)
    addi    %sp, %sp, 0xA0
	mtlr    %r0
	blr

 syscall8_stealth:

	lis     %r3, -0x7FFF
	ori     %r3, %r3, 3
	b       syscall8_end

 syscall8_unsupported:

	li     %r3, -1
	b      syscall8_end

 syscall8_bl:

	mtctr   %r29
	bctr

# ---------------------------------------------------------------------------

# another test ...
syscall8_desc2:
.org 0x120
		.long 0x80000000
		.long BASE + syscall8

.org 0x150	# empty for sys8 functions

# ---------------------------------------------------------------------------

	// system_call_2(8, 0, key): disables the syscalls vectors and fix a key to enable it again using system_call_2(8, 1, key)
 sys8_disable:

	LOAD_LABEL(%r27, %r31, save_syscall_values)
	std     %r3,  8(%r27) // save key

	li	    %r28, 1
	stw     %r28, 0(%r27) // stealth mode

	LOAD_ABS(%r4, %r31, SYSCALL_TABLE)

	ld      %r3, 37*8(%r4) // get unused syscall addr

	//ld      %r28, 6*8(%r4)
	//std     %r3,  6*8(%r4) // patch syscall 6 to stealth
	//std     %r28,  16(%r27)

	//ld      %r28, 7*8(%r4)
	//std     %r3,  7*8(%r4) // patch syscall 7 to stealth
	//std     %r28,  24(%r27)
	

    //std     %r3, 36*8(%r4) // patch syscall 36 to stealth

	li	    %r3, 0
	blr

      // dummy for system_call_2(8, 1, key)

 sys8_enable: // system_call_2(8, 1, key) when syscalls are enabled

	li	    %r3, SYS8_VERSION
	blr

 sys8_memcpy: // system_call_4(8, 2, dest, src, len)

	b      ABS(memcpy)

 sys8_memset: // system_call_4(8, 3, dest, dat, len)

	b      ABS(memset)

 sys8_call: // system_call_4(8, 4, addr, param1, param2)
	
	mtctr   %r3
	mr	    %r3, %r4
	mr	    %r4, %r5
	bctr

 sys8_alloc: // system_call_3(8, 5, size, pool)

	b      ABS(alloc)

 sys8_free: // system_call_3(8, 6, ptr, pool)

	b      ABS(free)

 sys8_panic: // system_call_1(8, 7)

	li      %r3, 0
	li      %r11, 0xFF
    sc	    1

 sys8_perm_mode: // system_call_2(8, 8, perm)

	LOAD_LABEL(%r27, %r31, perm_mode)
	stw	    %r3, 0(%r27)
	li	    %r3, 0
	blr

 sys8_open_table:  // system_call_2(8, 9, ptr)

	mr	    %r4, %r3
	LOAD_LABEL(%r27, %r31, str_open_cmp)
	ld	    %r3, 0(%r27)
    std	    %r4, 0(%r27)
	blr

##################################################################################

str_open_cmp: //for open path
	.quad 0

save_syscall_values: // (for stealth)
	.quad 0 // stealth mode
	.quad 0 // key
	.quad 0 // syscall 6
	.quad 0 // syscall 7

syscall8_table:
	QUAD_ABS(sys8_disable);
	QUAD_ABS(sys8_enable);
	QUAD_ABS(sys8_memcpy);
	QUAD_ABS(sys8_memset);
	QUAD_ABS(sys8_call);
	QUAD_ABS(sys8_alloc);
	QUAD_ABS(sys8_free);
	QUAD_ABS(sys8_panic);
	QUAD_ABS(sys8_perm_mode);
	QUAD_ABS(sys8_open_table);

perm_mode:
	.long PERM_MODE

#if DISABLE_HERMES_RESIDENT
.org 0x200
#else
.org 0x280
#endif
